% Part of the scripts/datasets for generating Figure 5 in the 3DNA
% 2003 Nucleic Acids Research paper. Originally written in Matlab at
% around 2002, slightly revised to make it work in GNU Octave v3.2.4
% (http://www.gnu.org/software/octave/)

% 2012-09-06 -- Xiang-Jun Lu (http://x3dna.org)

function draw_ellipse(mtx, rx, ry, cstyle)
    num=166;
    nstd=2;
    
    S = cov(mtx);                       % matlab -- cov(mtx, 1);
    Sinv = inv(S);
    Energy = [Sinv(1, 1)/2, Sinv(1, 2), Sinv(2, 2)/2];
    ave = mean(mtx);
    sd = std(mtx, 1);
    x_range = rx - ave(1);
    y_range = ry - ave(2);
    [X, Y] = meshgrid(linspace(x_range(1), x_range(2), num), ...
                      linspace(y_range(1), y_range(2), num));
    Z = Energy(1) * X.^2 + Energy(2) * X.*Y + Energy(3) * Y.^2;
    X = X + ave(1);
    Y = Y + ave(2);
    c_level = 0.5 * nstd * nstd;
    V = [c_level c_level];
    [ccc, h1] = contour(X, Y, Z, V, cstyle);
