% Part of the scripts/datasets for generating Figure 5 in the 3DNA
% 2003 Nucleic Acids Research paper. Originally written in Matlab at
% around 2002, slightly revised to make it work in GNU Octave v3.2.4
% (http://www.gnu.org/software/octave/)

% 2012-09-06 -- Xiang-Jun Lu (http://x3dna.org)

function pars = get_pars(parfile, ib, ie, ib2, ie2)
% Extract parameters in file "parfile", starting at column "ib",
%         ending at column "ie"

    if (nargin == 3)
        idx = ib : ie;
    elseif (nargin == 5)
        idx = [ib : ie  ib2 : ie2];
    else
        error('wrong number of input parameters');
    end
    
    fid = open_file(parfile);
    fout = open_file('pars.dat', 'w');
    while 1
        str = fgetl(fid);
        if ~ischar(str), break, end
        fprintf(fout, '%s\n', str(idx));
    end

    fclose(fid);
    fclose(fout);
    
    load pars.dat
